package net.sjava.cassandra.util;

import org.apache.thrift.TException;
import org.apache.thrift.protocol.TBinaryProtocol;
import org.apache.thrift.protocol.TProtocol;
import org.apache.thrift.transport.TFramedTransport;
import org.apache.thrift.transport.TSocket;
import org.apache.thrift.transport.TTransport;
import org.apache.thrift.transport.TTransportException;

import org.apache.cassandra.thrift.Cassandra;
import org.apache.cassandra.thrift.InvalidRequestException;

/**
 *  ϴ ü ִ ƿƼ Ŭ  
 * 
 * @author mcsong@gmail.com
 *
 */
public class ConnectionUtil {
	
	private static String HOST = "localhost";
	private static int PORT = 9160;
	private static boolean FRAMED = true;
	
	public static Cassandra.Client createConnection() throws TException {
		return createConnection(HOST, PORT, FRAMED);
	}
	
	public static Cassandra.Client createConnection(String keyspace) throws TException, InvalidRequestException {
		Cassandra.Client client = createConnection(HOST, PORT, FRAMED);
		client.set_keyspace(keyspace);
		return client;
	}
	
    private static Cassandra.Client createConnection(String host, Integer port, boolean framed) throws TTransportException {
        TSocket socket = new TSocket(host, port);
        TTransport trans = framed ? new TFramedTransport(socket) : socket;
        trans.open();
        TProtocol protocol = new TBinaryProtocol(trans);

        return new Cassandra.Client(protocol);
    }
}
